{--------------------------------------------}
{  estudo de matriz e String Grid            }
{  por Fabrcio S Costa                      }
{  http://fabriciojf.blogspot.com            }
{                                            }
{--------------------------------------------}

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, ExtCtrls, MMSystem;

type
   matriz_11x10 = array[0..10] of array[0..9] of string;
   matriz_2x100 = array[0..1] of array[0..99] of integer;

type
  TfMain = class(TForm)
    sg1: TStringGrid;
    lbInf: TLabel;
    Image1: TImage;
    pn1: TLabel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    img10: TImage;
    btnReiniciar: TSpeedButton;
    lbNivel: TLabel;
    img70: TImage;
    img80: TImage;
    img50: TImage;
    img60: TImage;
    img90: TImage;
    b50: TImage;
    b60: TImage;
    b70: TImage;
    b90: TImage;
    b80: TImage;
    img8: TImage;
    img7: TImage;
    img6: TImage;
    img5: TImage;
    img4: TImage;
    img3: TImage;
    img2: TImage;
    img1: TImage;
    procedure prDeletar();
    procedure sg1DblClick(Sender: TObject);
    procedure sg1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sg1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btnReiniciarClick(Sender: TObject);

  private
    { Private declarations }

    {boolean}
    booPress, boo, booExecutou, booInicio: boolean;

    {integer}
    qtde, indiceNivel, nivel, pontuacaoNivel, pontos, deletados: integer;
    colAntiga, rowAntiga, tempo, bonnus, contadorBonnus: integer;

    {matrizes e vetores}
    matrizPadrao: matriz_11x10;
    matrizDeletados: matriz_2x100;

    {string}
    valor1, valor2: string;

    procedure prColisao(val: string; y, x: integer);
    procedure prNiveis();
    procedure prReiniciar();
    procedure prPontos();
    procedure prMontar();
  public
    { Public declarations }

  end;

var
   fMain: TfMain;


implementation

uses Math;

{$R *.dfm}

procedure tfMain.prPontos();
begin
   pn1.Caption:= FormatFloat('###,###,###', pontos);
end;


procedure tfMain.prColisao(val: string; y, x: integer);
var
   i: integer;
begin

   qtde:= 0;
   i:= 1;

   if (y - i) >= 0 then
      while (sg1.Cells[y - i, x] = val) do
      begin
         matrizPadrao[y - i, x]:= 'X';
         i:= i + 1;
         qtde:= qtde + 1;

         if (y - i) < 0 then
            break;
      end;

   i:= 1;
   if (y + i) < sg1.ColCount then
      while (sg1.Cells[y + i, x] = val) do
      begin
         matrizPadrao[y + i, x]:= 'X';
         i:= i + 1;
         qtde:= qtde + 1;
         if (y + i) > sg1.ColCount -1 then
            break;
      end;

   if qtde < 2 then
      qtde:= 0;

   i:= 1;
   if (x - i) >= 0 then
      while (sg1.Cells[y, x - i] = val) do
      begin
         matrizPadrao[y, x - i]:= 'X';
         i:= i + 1;
         qtde:= qtde + 1;
         if (x - i) < 0 then
            break;
      end;

   i:= 1;
   if (x + i) < sg1.rowCount then
      while (sg1.Cells[y, x + i] = val) do
      begin
         matrizPadrao[y, x + i]:= 'X';
         i:= i + 1;
         qtde:= qtde + 1;
         if (x + i) > sg1.RowCount -1 then
            break;
      end;
end;

procedure TfMain.prMontar();
var
   i, n, no: integer;
begin
   randomize();

   for n:= 0 to sg1.RowCount -1 do
      for i:= 0 to sg1.ColCount -1 do
         if sg1.Cells[i, n] = '' then
         begin

            sg1.Cells[i, n]:= intToStr(random(indiceNivel));
            contadorBonnus:= contadorBonnus + 1;

            if bonnus = contadorBonnus then
            begin
               no:= random(3);
               if no = 0 then
                  sg1.Cells[i, n]:= '50'
               else if no = 1 then
                  sg1.Cells[i, n]:= '70'
               else
                  sg1.Cells[i, n]:= '90';

               contadorBonnus:= random(100);
            end;

            Application.ProcessMessages;
         end;

end;


procedure TfMain.prDeletar();
var
   x, y, i, s, m, linhas: integer;
   val: string;
begin

   val:= sg1.Cells[sg1.Col, sg1.Row];
   booExecutou:= false;

   // detecta e marca os quadros que colidem
   prColisao(val, sg1.Col, sg1.Row);

   x:= sg1.Row;
   y:= sg1.Col;

   if qtde >= 2 then
   begin

      matrizPadrao[y, x]:= 'X';

      deletados:= 1;
      {deleta as colises}
      for y:= 0 to sg1.ColCount -1 do
         for x:= 0 to sg1.RowCount -1 do
            if matrizPadrao[y, x] = 'X' then
            begin

               if sg1.Cells[y, x] = '50' then
               begin
                  sg1.Cells[y, x]:= 'b50';
                  pontos:= pontos + 500;
                  sndPlaySound(pChar('c:\windows\snd2.wav'), SND_ASYNC);
               end
               else if sg1.Cells[y, x] = '70' then
               begin
                  sg1.Cells[y, x]:= 'b70';
                  pontos:= pontos + 700;
                  sndPlaySound(pChar('c:\windows\snd2.wav'), SND_ASYNC);
               end
               else if sg1.Cells[y, x] = '90' then
               begin
                  sg1.Cells[y, x]:= 'b90';
                  pontos:= pontos + 900;
                  sndPlaySound(pChar('c:\windows\snd2.wav'), SND_ASYNC);
               end
               else
                  pontos:= pontos + (20 * deletados);

               prPontos();   
               sg1.Cells[y, x]:= '';
               matrizPadrao[y, x]:= '';

               matrizDeletados[0, deletados]:= x;
               matrizDeletados[1, deletados]:= y;

               deletados:= deletados + 1;
            end;

      linhas:= sg1.RowCount;

      // reindexa a matriz
      for y:= 0 to sg1.ColCount -1 do
         for x:= 0 to linhas do
            for i:= 0 to linhas -2 do
               if sg1.Cells[y, i + 1] = '' then
               begin
                  val:= sg1.Cells[y, i];
                  sg1.Cells[y, i]:= '';
                  sg1.Cells[y, i + 1]:= val;
               end;


      // remonta os espaoes vazios da matriz
      prMontar();
      sg1.cursor:= crDefault;
      booExecutou:= true;
      prNiveis();
   end;
end;


procedure TfMain.sg1DblClick(Sender: TObject);
begin
   prDeletar();
   boo:= false;
end;

procedure TfMain.sg1Click(Sender: TObject);
begin

   if boo = true then
   begin

      if ((sg1.Col in [colAntiga -1, colAntiga, colAntiga + 1]) and (sg1.Row in [rowAntiga - 1, rowAntiga, rowAntiga + 1])) then
      begin

         valor2:= sg1.Cells[sg1.Col, sg1.row];
         sg1.Cells[colAntiga, rowAntiga]:= valor2;
         sg1.Cells[sg1.Col, sg1.row]:= valor1;
         prDeletar();
         lbInf.Caption:= 'Bejeweled 1.0';

         if booExecutou = false then
         begin
            sg1.Cells[colAntiga, rowAntiga]:= valor1;
            sg1.Cells[sg1.Col, sg1.row]:= valor2;
            lbInf.Caption:= 'Movimento Invlido';
         end;
      end
      else
         lbInf.Caption:= 'Movimento Invlido';

      sg1.cursor:= crDefault;
      boo:= false;
   end
   else
   begin
      boo:= true;
      valor1:= sg1.Cells[sg1.Col, sg1.row];
      colAntiga:= sg1.Col;
      rowAntiga:= sg1.Row;
      sg1.cursor:= crHandPoint;
   end;
   sg1.SetFocus;
end;

procedure TfMain.FormCreate(Sender: TObject);
begin

   Randomize();

   {iniciando as variaveis}

   {boolean}
   booExecutou:= true;
   booPress:= false;
   boo:= false;

   {integer}
   contadorBonnus:= random(100);
   pontuacaoNivel:= 15000;
   indiceNivel:= 4;
   bonnus:= 100;
   nivel:= 1;

   {caption informativo}
   lbInf.Caption:= 'Bejeweled 1.0';
   pontos:= 0;

   {montar a matriz}
   prMontar();;
end;

procedure TfMain.sg1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
   if sg1.Cells[aCol, aRow] = '0' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img1.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '1' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img2.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '2' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img3.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '3' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img4.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '4' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img5.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '5' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img6.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '6' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img7.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '7' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img8.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '50' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img50.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '70' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img70.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = '90' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, img90.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = 'b50' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, b50.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = 'b70' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, b70.Picture.Graphic)
   else if sg1.Cells[aCol, aRow] = 'b90' then
      sg1.Canvas.Draw(rect.Left, Rect.Top, b90.Picture.Graphic)
   else
      sg1.Canvas.Draw(rect.Left, Rect.Top, img10.Picture.Graphic);

end;


procedure TfMain.SpeedButton1Click(Sender: TObject);
begin
   close;
end;

procedure TfMain.SpeedButton2Click(Sender: TObject);
begin
   WindowState:= wsMinimized;
end;

procedure TfMain.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   booPress:= true;
end;

procedure TfMain.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   booPress:= false;
end;

procedure TfMain.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   pt: tPoint;
begin

   GetCursorPos(pt);

   If booPress = true then
   begin
      fMain.Left:= (pt.x);
      fMain.top:= (pt.y);
   end;
end;

procedure TfMain.btnReiniciarClick(Sender: TObject);
begin
   FormCreate(Sender);
   prReiniciar();
end;

procedure tfMain.prNiveis();
begin


   if (pontos >= (pontuacaoNivel * 2)) then
   begin

      pontuacaoNivel:= pontos;

      indiceNivel:= 3 + nivel;
      nivel:= nivel + 1;

      prReiniciar();
      lbNivel.Caption:= 'Nvel ' + intToStr(nivel);
      lbInf.Caption:= 'Nvel ' + intToStr(nivel);

      if nivel = 8 then
      begin
         showMessage('Parabns voc  o novo recordista do game Bejeweled');

         indiceNivel:= 4;
         nivel:= 1;

         pontos:= 0;
         prReiniciar();
      end;
   end;
end;


procedure tfMain.prReiniciar();
var
   x, y: integer;
begin

   {limpa todo mundo}
   for y:= 0 to sg1.ColCount -1 do
      for x:= 0 to sg1.RowCount -1 do
      begin
         sg1.Cells[y, x]:= '';
         matrizPadrao[y, x]:= '';
      end;

    prMontar();
end;

end.
